/*
 *	standard system class & generic function declarations
 *			
 *								Copyright - John Wainwright
 *
 */

extern class	Class;
extern class  	Object;
extern class  	List;
extern class  	Replist;
extern class  	String;
extern class  	Linkseq;
extern class  	Collect;
extern class  	List2;
extern class  	IndexMixin;
extern class  	DependentsMixin;
extern class	Stream;
extern class	StdioStream;
extern class	NameTable;

extern object	screen;
extern object	error;

typedef object	replist;
typedef object	string;
typedef object	list;
typedef object	linkseq;

externGeneric(add,			addGeneric)
externGeneric(allInstances,	allInstancesGeneric)
externGeneric(append,		appendGeneric)	
externGeneric(assoc,		assocGeneric)
externGeneric(bind,			bindGeneric)		
externGeneric(cantDo,		cantDoGeneric)		
externGeneric(car,			carGeneric)		
externGeneric(cdr,			cdrGeneric)		
externGeneric(changed,		changedGeneric)		
externGeneric(changing,		changingGeneric)		
externGeneric(className,	classNameGeneric)
externGeneric(copy,			copyGeneric)
externGeneric(declare, 		declareGeneric)
externGeneric(deepCopy,		deepCopyGeneric)
externGeneric(deepDispose,	deepDisposeGeneric)
externGeneric(deepInstances, deepInstancesGeneric)
externGeneric(delete,		deleteGeneric)
externGeneric(dltDependent,	dltDependentGeneric)
externGeneric(addDependent,	addDependentGeneric)
externGeneric(dependentsOf,	dependentsOfGeneric)
externGeneric(dispose,		disposeGeneric)
externGeneric(draw,			drawGeneric)
externGeneric(equal,		equalGeneric)		
externGeneric(enlarge,		enlargeGeneric)		
externGeneric(forAll,		forAllGeneric)
externGeneric(forAllGen,	forAllGenGeneric)
externGeneric(freePart,		freePartGeneric)		
externGeneric(get,			getGeneric)		
externGeneric(getBinding,	getBindingGeneric)		
externGeneric(gprintf, 		gprintfGeneric)		
externGeneric(hasChanged,	hasChangedGeneric)
externGeneric(head,			headGeneric)
externGeneric(hashOf,		hashOfGeneric)
externGeneric(init,			initGeneric)
externGeneric(isChanging,	isChangingGeneric)
externGeneric(isEmpty,		isEmptyGeneric)
externGeneric(isKey,		isKeyGeneric)
externGeneric(isKeyEqual,	isKeyEqualGeneric)
externGeneric(join,			joinGeneric)
externGeneric(keyOf, 		keyOfGeneric)
externGeneric(name,			nameGeneric)		
externGeneric(nameOf,		nameOfGeneric)		
externGeneric(map,			mapGeneric)
externGeneric(moreInSeq,	moreInSeqGeneric)
externGeneric(new,			newGeneric)		
externGeneric(next,			nextGeneric)
externGeneric(nextKey, 		nextKeyGeneric)
externGeneric(nth,			nthGeneric)
externGeneric(print,		printGeneric)
externGeneric(push,			pushGeneric)
externGeneric(put, 			putGeneric)
externGeneric(repList,		repListGeneric)
externGeneric(restart,		restartGeneric)
externGeneric(second,		secondGeneric)
externGeneric(sequence,		sequenceGeneric)	
externGeneric(set,			setGeneric)	
externGeneric(softBind,		softBindGeneric)	
externGeneric(start,		startGeneric)
externGeneric(stringOf,		stringOfGeneric)	
externGeneric(subs,			subsGeneric)
externGeneric(supers,		supersGeneric)
externGeneric(tail,			tailGeneric)
externGeneric(third,		thirdGeneric)
externGeneric(valueOf,		valueOfGeneric)
