/*
 *	standard system generic function declarations
 *
 *			Copyright  John Wainwright 1988
 *
 */

#include "oic.h"
#include "generics.h"

defGeneric(add, 			addGeneric, 		"add")
defGeneric(addDependent, 	addDependentGeneric, "addDependent")
defGeneric(allInstances, 	allInstancesGeneric, "allInstances")
defGeneric(append, 			appendGeneric, 		"append")	
defGeneric(assoc, 			assocGeneric, 		"assoc")
defGeneric(bind, 			bindGeneric, 		"bind")		
defGeneric(cantDo, 			cantDoGeneric, 		"cantDo")		
defGeneric(car, 			carGeneric, 		"car")		
defGeneric(cdr, 			cdrGeneric, 		"cdr")		
defGeneric(changed, 		changedGeneric, 	"changed")		
defGeneric(changing, 		changingGeneric, 	"changing")		
defGeneric(className,		classNameGeneric, 	"className")
defGeneric(copy, 			copyGeneric, 		"copy")
defGeneric(declare, 		declareGeneric, 	"declare")
defGeneric(deepCopy, 		deepCopyGeneric, 	"deepCopy")
defGeneric(deepDispose, 	deepDisposeGeneric, "deepDispose")
defGeneric(deepInstances,	deepInstancesGeneric, "deepInstances")
defGeneric(delete, 			deleteGeneric, 		"delete")
defGeneric(dependentsOf, 	dependentsOfGeneric, "dependentsOf")
defGeneric(dispose, 		disposeGeneric, 	"dispose")
defGeneric(dltDependent, 	dltDependentGeneric, "dltDependent")
defGeneric(draw, 			drawGeneric, 		"draw")
defGeneric(equal, 			equalGeneric, 		"equal")		
defGeneric(enlarge, 		enlargeGeneric, 	"enlarge")		
defGeneric(forAll, 			forAllGeneric, 		"forAll")
defGeneric(forAllGen, 		forAllGenGeneric, 	"forAllGen")
defGeneric(freePart, 		freePartGeneric, 	"freePart")		
defGeneric(get, 			getGeneric, 		"get")		
defGeneric(getBinding, 		getBindingGeneric, 	"getBinding")		
defGeneric(gprintf, 		gprintfGeneric, 	"gprintf")		
defGeneric(hasChanged, 		hasChangedGeneric, 	"hasChanged")
defGeneric(hashOf, 			hashOfGeneric, 		"hashOf")
defGeneric(head, 			headGeneric, 		"head")
defGeneric(init, 			initGeneric, 		"init")
defGeneric(isEmpty, 		isEmptyGeneric, 	"isEmpty")
defGeneric(isChanging, 		isChangingGeneric, 	"isChanging")
defGeneric(isKey, 			isKeyGeneric, 		"isKey")
defGeneric(isKeyEqual, 		isKeyEqualGeneric, 	"isKeyEqual")
defGeneric(join, 			joinGeneric, 		"join")
defGeneric(keyOf, 			keyOfGeneric, 		"keyOf")
defGeneric(map,				mapGeneric,			"map")
defGeneric(moreInSeq,  		moreInSeqGeneric,   "moreInSeq")
defGeneric(name,			nameGeneric,		"name")		
defGeneric(nameOf,			nameOfGeneric,		"nameOf")		
defGeneric(new, 			newGeneric, 		"new")		
defGeneric(next, 			nextGeneric, 		"next")
defGeneric(nextKey, 		nextKeyGeneric, 	"nextKey")
defGeneric(nth, 			nthGeneric, 		"nth")
defGeneric(print, 			printGeneric, 		"print")
defGeneric(push, 			pushGeneric, 		"push")
defGeneric(put, 			putGeneric, 		"put")
defGeneric(repList, 		repListGeneric, 	"repList")
defGeneric(restart, 		restartGeneric, 	"restart")
defGeneric(second, 			secondGeneric, 		"second")
defGeneric(sequence, 		sequenceGeneric, 	"sequence")	
defGeneric(set, 			setGeneric, 		"set")	
defGeneric(softBind, 		softBindGeneric, 	"softBind")	
defGeneric(start, 			startGeneric, 		"start")
defGeneric(stringOf, 		stringOfGeneric, 	"stringOf")	
defGeneric(subs,			subsGeneric, 		"subs")
defGeneric(supers,			supersGeneric, 		"supers")
defGeneric(tail, 			tailGeneric, 		"tail")
defGeneric(third, 			thirdGeneric, 		"third")
defGeneric(valueOf, 		valueOfGeneric, 	"valueOf")

InitSysClasses()		
{
	InitIndexMixin();
	InitDependentsMixin();
	InitStdioStream();
	InitList();
	InitReplist();
	InitString();
	InitLinkseq();
	InitCollect();
	InitList2();
}
